<template>
  <div class="px-5">
    <v-card
      max-width="100%"
      flat
      class="mx-auto my-5 pb-5   grey lighten-3"
    >
      <v-card
        class="card d-flex flex-wrap mx-3"
        color="primary"
        dark
      >
        <v-col
          class="text-center"
          cols="12"
          sm="6"
        >
          <span
            class="subtitle-1"
          >
            LIST OF EMPLOYEE
          </span>
        </v-col>
         <v-col
          class="text-center"
          cols="12"
          sm="6"
        >
          <v-btn
            class="mx-auto"
            tile outlined
            :disabled="disabled"
            color="white"
            to="/addemployee"
          >
            <v-icon left>mdi-folder-plus</v-icon> ADD EMPLOYEE
          </v-btn>
        </v-col>
      </v-card>
      <v-row
        class="my-3 hidden-xs-only"
        no-gutters
      >
        <v-col class="text-center">
          <span class="caption black--text">EMP ID</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">EMP NAME</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">DEPARTEMENT</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">CREATED DATE</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">STATUS</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">ACTION</span>
        </v-col>
      </v-row>
      <v-divider class="mb-4"></v-divider>
      <v-row
        outlie
        v-for="(item, index) in employee"
        :key="item.id"
        class="my-3 mx-2 white py-4 row_outlined"
        no-gutters
      >
        <v-col class="text-center" cols="12" sm="1">
          <span class="caption black--text hidden-sm-and-up px-3">EMPLOYEE ID :</span>
          <span class="caption black--text">{{ item.employeecode }}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="3">
          <span class="caption black--text hidden-sm-and-up px-3">EMPLOYEE NAME :</span>
          <span class="caption black--text">{{ item.firstname }} {{ item.lastname}}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="2">
          <span class="caption black--text hidden-sm-and-up px-3">DEPARTEMENT :</span>
          <span class="caption black--text">{{ item.department }}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="2">
          <span class="caption black--text hidden-sm-and-up px-3">CREATED DATE :</span>
          <span class="caption black--text">{{ [item.dateCreated, 'x'] | moment('D MMM YY')}}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="2">
          <span class="caption black--text hidden-sm-and-up px-3">STATUS :</span>
          <span class="caption green--text">Active</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="2">
          <span class="caption black--text hidden-sm-and-up px-3">ACTION :</span>
          <v-btn
            icon
            class="secoundary--text"
            :disabled="disabled"
            :to="{ name: 'EmployeeEdit', params: { id: `${item.id}` }}"
          >
            <v-icon>mdi-pencil</v-icon>
          </v-btn>
          <v-btn
            :disabled="disabled"
            icon class="secoundary--text"
            v-on:click="deleteNote(index)"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
         </v-col>
      </v-row>
      <v-row class="px-7 py-3">
        <v-btn class="mx-2" :disabled="prevBtnDisabled" @click="prev">Prev</v-btn>
        <v-btn class="mx-2" :disabled="nextBtnDisabled" @click="next">Next</v-btn>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import { mapGetters } from 'vuex';
import { getAuthenticatedUser } from '@/fb';
import Employee from '@/models/Employee';
import { getCurrentUser } from '@/firebase/db';
import EmployeeList from '@/models/EmployeeList';

export default {
  data() {
    return {
      employee: [],
      disabled: true,
      prevBtnDisabled: true,
      nextBtnDisabled: true,
    };
  },
  computed: {
    ...mapGetters({
      user: 'getUser',
    }),
  },
  mounted() {
    getCurrentUser().getIdTokenResult().then((idTokenResult) => {
      if (idTokenResult.claims.admin) {
        this.disabled = false;
      } else {
        this.disabled = true;
      }
    });
    getAuthenticatedUser().then((user) => {
      console.log('hello this is user', user);
      this.employeeDetails = new EmployeeList(
        { uid: user.uid, className: Employee.getClassName() },
      );
      console.log('this function work');
      this.employeeDetails.fetch({ orderBy: 'dateCreated', paginate: true })
        .then((page) => {
          this.employee = page.data;
          console.log('this is final list you are seeing right now  !!!!!!!!!!!!!!!', this.employee);
          if (page.hasNext()) {
            this.nextBtnDisabled = false;
            console.log('@@222', this.nextBtnDisabled);
          }
        });
    });
  },
  methods: {
    next() {
      this.employeeDetails.next().then((page) => {
        // this.$log.debug(noteList);
        this.employee = page.data;
        this.prevBtnDisabled = false;
        if (page.hasNext()) {
          this.nextBtnDisabled = false;
        } else {
          this.nextBtnDisabled = true;
        }
      });
    },
    prev() {
      this.employeeDetails.prev().then((page) => {
        this.employee = page.data;
        this.nextBtnDisabled = false;
        if (page.hasPrevious()) {
          this.prevBtnDisabled = false;
        } else {
          this.prevBtnDisabled = true;
        }
      });
    },
    deleteNote(index) {
      console.log(index);
      this.employee[index].delete().then(() => {
        this.employee.splice(index, 1);
      });
    },
  },

};
</script>

<style scoped>
.card {
  top: -10px;
}
.row_outlined {
  outline: #1b0052 solid 1px;
  margin: auto;
}
</style>
